LorealInstagram = (function(global) {
    const ID_MAIN_IMG_DIV = '1555362273993';
    //const ID_EXTERNAL_LINK_DIV = '1527018861449';
   // const ID_PROFILE_PIC_IMG_DIV = '1526586631698';

    function LorealInstagram() { };

    var truncateText = function(text, length) {
        if (text.length <= length) {
            return text;
        }
        return text.substring(0, length) + '...';
    };

    var applyObjectFitToMainImage = function(imgObjectFit) {
   //     document.getElementById(ID_MAIN_IMG_DIV).getElementsByTagName('img')[0].style['object-fit'] = imgObjectFit;
		//console.log ( ID_MAIN_IMG_DIV );
    };

    var moveImageUp = function(pixels) {
        document.getElementById(ID_MAIN_IMG_DIV).style.top = parseInt(document.getElementById(ID_MAIN_IMG_DIV).style.top) - pixels;
    };

    var showExternalLink = function(url) {
        document.getElementById(ID_EXTERNAL_LINK_DIV).style.visibility = 'visible';
        document.getElementById(ID_EXTERNAL_LINK_DIV)
            .getElementsByTagName('div')[0]
            .getElementsByTagName('p')[0].innerHTML = extractHostname(url);
    };

    var extractHostname = function(url) {
        var hostname;
        if (url.indexOf("://") > -1) {
            hostname = url.split('/')[2];
        }
        else {
            hostname = url.split('/')[0];
        }
        hostname = hostname.split(':')[0];
        hostname = hostname.split('?')[0];

        return hostname;
    }
    /*
    var showProfilePic = function (profileName, imgUrl) {
        getRequest(
            imgUrl,
            function success(data) {
                storeProfileImage(profileName, imgUrl);
                setProfilePic(imgUrl);
            },
            function error(data) {
                if (localStorage.getItem(profileName) !== null) {
                    setProfilePic(localStorage.getItem(profileName));
                }
            }
        );
        document.getElementById(ID_PROFILE_PIC_IMG_DIV).getElementsByTagName('img')[0].src = imgUrl;
    };
	*/
    var getRequest = function (uri, success, error) {
        var ajax = new XMLHttpRequest();
        ajax.open("GET", uri, true);
        ajax.send();
        ajax.onreadystatechange = function() {
            if (ajax.readyState === 4 && ajax.status === 200) {
                var data = ajax.responseText;
                success(data);
                return;
            }
            error(data);
        }
    };

    var storeProfileImage = function(profileName, imgUrl) {
        toDataURL(
            imgUrl,
            function(dataUrl) {
                localStorage.setItem(profileName, dataUrl);
            }
        );
    };

    var setProfilePic = function(imgSrc) {
        document.getElementById(ID_PROFILE_PIC_IMG_DIV).getElementsByTagName('img')[0].src = imgSrc;
    };

    var toDataURL = function (src, callback, outputFormat) {
        var img = new Image();
        img.crossOrigin = 'Anonymous';
        img.onload = function() {
            var canvas = document.createElement('CANVAS');
            var ctx = canvas.getContext('2d');
            var dataURL;
            canvas.height = this.naturalHeight;
            canvas.width = this.naturalWidth;
            ctx.drawImage(this, 0, 0);
            dataURL = canvas.toDataURL(outputFormat);
            callback(dataURL);
        };
        img.src = src;
        if (img.complete || img.complete === undefined) {
            img.src = "data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///ywAAAAAAQABAAACAUwAOw==";
            img.src = src;
        }
    };

    LorealInstagram.prototype.applyObjectFitToMainImage = applyObjectFitToMainImage;
    LorealInstagram.prototype.truncateText = truncateText;
    LorealInstagram.prototype.moveImageUp = moveImageUp;
    LorealInstagram.prototype.showExternalLink = showExternalLink;
    //LorealInstagram.prototype.showProfilePic = showProfilePic;

    return LorealInstagram;
})(window);